%%%-------------------------------------------------------------------
%%% @author Konstantin Kalin <kkalin@kkalin-macbook.local>
%%% @copyright (C) 2012, Konstantin Kalin
%%% @doc
%%%
%%% @end
%%% Created : 23 Apr 2012 by Konstantin Kalin <kkalin@kkalin-macbook.local>
%%%-------------------------------------------------------------------
-module(publisher).

-export([start/1, start/2, start_publish/6, start_publish/4]).

start(Urls) ->
    application:start(sasl),
    application:start(publisher),
    init_connections(Urls, 1).

start(Urls, Factor) ->
    application:start(sasl),
    application:start(publisher),
    init_connections(Urls, Factor).

init_connections(Urls, Factor) ->
    connections_sup:start_link(Urls, Factor).

start_publish(Exchange, Type, Count, Rate) ->
    Connection = connections:get(),
    publisher_sup:start_publish(Connection, Exchange, Type, <<"1">>, Count, Rate).

start_publish(_Exchange, _Type, _Count, _Rate, 0, _Index) ->
    ok;
start_publish(Exchange, Type, Count, Rate, Amount, Index) ->
    Key = << <<"key.">>/binary, (list_to_binary(integer_to_list(Amount + Index)))/binary >>,
    Connection = connections:get_connection(), 
    publisher_sup:start_publish(Connection, Exchange, Type, Key, Count, Rate),
    start_publish(Exchange, Type, Count, Rate, (Amount - 1), Index).
